searchNodes=[{"type":"module","title":"Membrane.FFmpeg.SWScale.PixelFormatConverter","doc":"This element performs conversion between pixel formats of raw video. Only the following pixel formats are supported, both as input and output: I420 I422 I444 RGB BGRA RGBA NV12 NV21 AYUV YUY2 Element options Passed via struct Membrane.FFmpeg.SWScale.PixelFormatConverter.t/0 format RawVideo . pixel_format_t ( ) Required Desired pixel format of output video. Pads :input Accepted formats: % RawVideo { aligned : true , pixel_format : pixel_format } when pixel_format in @supported_pixel_formats Direction: :input Availability: :always Flow control: :auto Demand unit: :buffers :output Accepted formats: % RawVideo { aligned : true , pixel_format : pixel_format } when pixel_format in @supported_pixel_formats Direction: :output Availability: :always Flow control: :auto Demand unit: nil","ref":"Membrane.FFmpeg.SWScale.PixelFormatConverter.html"},{"type":"function","title":"Membrane.FFmpeg.SWScale.PixelFormatConverter.options/0","doc":"Returns description of options available for this module","ref":"Membrane.FFmpeg.SWScale.PixelFormatConverter.html#options/0"},{"type":"type","title":"Membrane.FFmpeg.SWScale.PixelFormatConverter.t/0","doc":"Struct containing options for Membrane.FFmpeg.SWScale.PixelFormatConverter","ref":"Membrane.FFmpeg.SWScale.PixelFormatConverter.html#t:t/0"},{"type":"module","title":"Membrane.FFmpeg.SWScale.Scaler","doc":"This element performs video scaling, using SWScale module of FFmpeg library. There are two options that can be specified when creating Scaler: output_width - desired scaled video width. output_height - desired scaled video height. Both need to be even numbers. Note that if only one dimension is specified (either output_width or output_height ), the other dimension is calculated on handle_stream_format callback based on input dimensions. Scaling consists of two operations: scaling itself - resizing video frame with keeping original ratio. After that operation at least one of the dimensions of the input frame match the respective dimension of the desired output size. The second one (if does not match) is smaller than its respective dimension. adding paddings - if one dimension does not match after scaling, paddings have to be added. They are put on both sides of the scaled frame equally. They are either above and below the frame or on the left and right sides of it. It depends on the dimension that did not match after scaling. Scaler needs input in the YUV420p format, processes one frame at a time and requires getting stream format with input video width and height. To meet all requirements either Membrane.Element.RawVideo.Parser or some decoder (e.g. Membrane.H264.FFmpeg.Decoder ) have to precede Scaler in the pipeline. The output of the element is also in the YUV420p format. It has the size as specified in the options. All stream format except for width and height are passed unchanged to the next element in the pipeline. Element options Passed via struct Membrane.FFmpeg.SWScale.Scaler.t/0 output_width non_neg_integer ( ) Default value: nil Width of the scaled video. output_height non_neg_integer ( ) Default value: nil Height of the scaled video. use_shm? boolean ( ) Default value: false If true, native scaler will use shared memory (via Shmex.t/0 ) for storing frames Pads :input Accepted formats: % RawVideo { pixel_format : :I420 , aligned : true } Direction: :input Availability: :always Flow control: :auto Demand unit: :buffers :output Accepted formats: % RawVideo { pixel_format : :I420 , aligned : true } Direction: :output Availability: :always Flow control: :auto Demand unit: nil","ref":"Membrane.FFmpeg.SWScale.Scaler.html"},{"type":"function","title":"Membrane.FFmpeg.SWScale.Scaler.options/0","doc":"Returns description of options available for this module","ref":"Membrane.FFmpeg.SWScale.Scaler.html#options/0"},{"type":"type","title":"Membrane.FFmpeg.SWScale.Scaler.t/0","doc":"Struct containing options for Membrane.FFmpeg.SWScale.Scaler","ref":"Membrane.FFmpeg.SWScale.Scaler.html#t:t/0"},{"type":"module","title":"Membrane.FFmpeg.SWScale.Scaler.Native","doc":"This module provides natively implemented scaler utilizing library swscale.","ref":"Membrane.FFmpeg.SWScale.Scaler.Native.html"},{"type":"function","title":"Membrane.FFmpeg.SWScale.Scaler.Native.create/4","doc":"","ref":"Membrane.FFmpeg.SWScale.Scaler.Native.html#create/4"},{"type":"function","title":"Membrane.FFmpeg.SWScale.Scaler.Native.scale/3","doc":"","ref":"Membrane.FFmpeg.SWScale.Scaler.Native.html#scale/3"},{"type":"extras","title":"Membrane FFmpeg SWScale plugin","doc":"Plugin providing an element scaling raw video frames and performing pixel format conversions, using SWScale module of FFmpeg library. It is a part of Membrane Multimedia Framework .","ref":"readme.html"},{"type":"extras","title":"Membrane FFmpeg SWScale plugin - Installation","doc":"Add the following line to your deps in mix.exs . Run mix deps.get . { :membrane_ffmpeg_swscale_plugin , &quot;~&gt; 0.13.0&quot; } You also need to have FFmpeg library with development headers installed on your system.","ref":"readme.html#installation"},{"type":"extras","title":"Membrane FFmpeg SWScale plugin - Description","doc":"PixelFormatConverter PixelFormatConverter accepts raw video in any of the pixel formats specified in type Membrane.RawVideo.pixel_format_t() as input and is capable of producing output in any of these pixel formats. When creating the element you need to specify a single option format defining the desired pixel format of the output. The element requires Membrane.RawVideo stream format on the input with aligned: true constraint, meaning that each buffer must contain exactly one raw video frame. Scaler Scaler needs input in the YUV420p format, processes one frame at a time and requires getting stream format with input video width and height. To meet all requirements either Membrane.RawVideo.Parser or some decoder (e.g. Membrane.H264.FFmpeg.Decoder ) have to precede Scaler in the pipeline. There are two options that have to be specified when creating the element: output_width - desired scaled video width. output_height - desired scaled video height. Both need to be even numbers. Scaling consists of two operations: scaling itself - resizing video frame with keeping original ratio. After that operation at least one of the dimensions of the input frame match the respective dimension of the desired output size. The second one (if does not match) is smaller than its respective dimension. adding paddings - if one dimension does not match after scaling, paddings have to be added. They are put on both sides of the scaled frame equally. They are either above and below the frame or on the left and right sides of it. It depends on the dimension that did not match after scaling. The output of the element is also in the YUV420p format. It has the size as specified in the options.","ref":"readme.html#description"},{"type":"extras","title":"Membrane FFmpeg SWScale plugin - Usage","doc":"Membrane.FFmpeg.SWScale.Scaler Scaling an encoded (using H.264 standard) video requires parser and decoder because Scaler scales only raw, decoded video. The pipeline scales the video and reencodes it. defmodule Scaling.Pipeline do use Membrane.Pipeline @impl true def handle_init ( _ctx , _options ) do structure = [ child ( :file_src , % Membrane.File.Source { location : &quot;/tmp/input.h264&quot; } ) |&gt; child ( :parser , Membrane.H264.FFmpeg.Parser ) |&gt; child ( :decoder , Membrane.H264.FFmpeg.Decoder ) |&gt; child ( :scaler , % Membrane.FFmpeg.SWScale.Scaler { output_width : 640 , output_height : 640 } ) |&gt; child ( :encoder , Membrane.H264.FFmpeg.Encoder ) |&gt; child ( :file_sink , % Membrane.File.Sink { location : &quot;/tmp/output.h264&quot; } ) ] { [ spec : structure } , %{ } } end end Membrane.FFmpeg.SWScale.PixelFormatConverter Converting the pixel format of an encoded (using H.264 standard) video requires a parser and a decoder because the Converter performs conversion only on the raw , decoded video. The pipeline changes the pixel format of the video to the I422 format and reencodes it. defmodule Converting.Pipeline do use Membrane.Pipeline @impl true def handle_init ( _ctx , _options ) do structure = [ child ( :file_src , % Membrane.File.Source { location : &quot;/tmp/input.h264&quot; } ) |&gt; child ( :parser , Membrane.H264.FFmpeg.Parser ) |&gt; child ( :decoder , Membrane.H264.FFmpeg.Decoder ) |&gt; child ( :converter , % Membrane.FFmpeg.SWScale.PixelFormatConverter { format : :I422 } ) |&gt; child ( :encoder , Membrane.H264.FFmpeg.Encoder ) |&gt; child ( :file_sink , % Membrane.File.Sink { location : &quot;/tmp/output.h264&quot; } ) ] { [ spec : structure ] , %{ } } end end","ref":"readme.html#usage"},{"type":"extras","title":"Membrane FFmpeg SWScale plugin - Copyright and License","doc":"Copyright 2021, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2020 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html"}]